GLIB-MKENUMS(1)

NAME
glib-mkenums - C language enum description generation utility

SYNOPSIS

glib-mkenums [OPTION...] [FILE...]

DESCRIPTION

glib-mkenums is a small perl-script utility that parses C code to extract enum definitions and produces enum descriptions based on text templates specified by the user. Most frequently this script is used to produce C code that contains enum values as strings so programs can provide value name strings for introspection.

glib-mkenums takes a list of valid C code files as input. The options specified control the text that is output, certain substitutions are performed on the text templates for keywords enclosed in @ characters.

  Production text substitutions

Certain keywords enclosed in @ characters will be substituted in the emitted text. For the substitution examples of the keywords below, the following example enum definition is assumed:

@EnumName@
    The name of the enum currently being processed, enum names are assumed to be properly namespaced and to use mixed capitalization to separate words (e.g. PrefixTheXEnum).

@enum_name@
    The enum name with words lowercase and word-separated by underscores (e.g. prefix_the_xenum).

@ENUMNAME@
    The enum name with words uppercase and word-separated by underscores (e.g. PREFIX_THE_XENUM).

@ENUMSHORT@
    The enum name with words uppercase and word-separated by underscores, prefix stripped (e.g. THE_XENUM).

@ENUMPREFIX@
    The prefix of the enum name (e.g. PREFIX).

@VALUENAME@
    The enum value name currently being processed with words uppercase and word-separated by underscores, this is the assumed literal notation of enum values in the C sources (e.g. PREFIX_THE_XVALUE).

@valuenick@
    A nick name for the enum value currently being processed, this is usually generated by stripping common prefix words of all the enum values of the current enum, the words are lowercase and underscores are substituted by a minus (e.g. the-xvalue).

@valuenum@
    The integer value for the enum value currently being processed. This is calculated by using perl to attempt to evaluate the expression as it appears in the C source code. If evaluation fails then glib-mkenums will exit with an error status, but this only happens if @valuenum@ appears in your value production template. (Since: 2.26)

@type@
    This is substituted either by "enum" or "flags", depending on whether the enum value definitions contained bit-shift operators or not (e.g. flags).

@Type@
    The same as @type@ with the first letter capitalized (e.g. Flags).

@TYPE@
    The same as @type@ with all letters uppercased (e.g. FLAGS).

@filename@
    The name of the input file currently being processed (e.g. foo.h).

@basename@
    The base name of the input file currently being processed (e.g. foo.h). (Since: 2.22)

  Trigraph extensions

Some C comments are treated specially in the parsed enum definitions, such comments start out with the trigraph sequence /*< and end with the trigraph sequence >*/. Per enum definition, the options "skip" and "flags" can be specified, to indicate this enum definition to be skipped, or for it to be treated as a flags definition, or to specify the common prefix to be stripped from all values to generate value nicknames, respectively. The "underscore_name" option can be used to specify the word separation used in the *_get_type() function. For instance, /*< underscore_name=gnome_vfs_uri_hide_options >*/.

Per value definition, the options "skip" and "nick" are supported. The former causes the value to be skipped, and the latter can be used to specify the otherwise auto-generated nickname. Examples:

OPTIONS

--fhead TEXT
    Put out TEXT prior to processing input files.

--fprod TEXT
    Put out TEXT everytime a new input file is being processed.

--ftail TEXT
    Put out TEXT after all input files have been processed.

--eprod TEXT
    Put out TEXT everytime an enum is encountered in the input files.

--vhead TEXT
    Put out TEXT before iterating over the set of values of an enum.

--vprod TEXT
    Put out TEXT for every value of an enum.

--vtail TEXT
    Put out TEXT after iterating over all values of an enum.

--comments TEXT
    Template for auto-generated comments, the default (for C code generations) is "/* @comment@ */".

--template FILE
    Read templates from the given file. The templates are enclosed in specially-formatted C comments

    where section may be file-header, file-production, file-tail, enumeration-production, value-header, value-production, value-tail or comment.

--identifier-prefix PREFIX
    Indicates what portion of the enum name should be intepreted as the prefix (eg, the "Gtk" in "GtkDirectionType"). Normally this will be figured out automatically, but you may need to override the default if your namespace is capitalized oddly.

--symbol-prefix PREFIX
    Indicates what prefix should be used to correspond to the identifier prefix in related C function names (eg, the "gtk" in "gtk_direction_type_get_type". Equivalently, this is the lowercase version of the prefix component of the enum value names (eg, the "GTK" in "GTK_DIR_UP". The default value is the identifier prefix, converted to lowercase.

--help
    Print brief help and exit.

--version
    Print version and exit.

SEE ALSO

glib-genmarshal(1)